/*User interface functions*/
gint startchase(GtkWidget *widget, gpointer data)
{
    chasing_active=1;
    return C_OK;
}


gint stopchase(GtkWidget *widget, gpointer data)
{
    chasing_active=0;

    distanceInCmParameter=180;
    pixelsFromCenterParameter=0;

    userenable=0;
    userpitch=0;
    userroll=0;
    usergaz=0;
    useryaw=0;

    ardrone_at_set_progress_cmd(0,0,0,0,0);

    return C_OK;
}

gint startintel(GtkWidget *widget, gpointer data)
{
    intel_active = 1;
    return C_OK;
}

gint stoptintel(GtkWidget *widget, gpointer data)
{
    intel_active = 0;
    return C_OK;
}

gint takeoff(GtkWidget *widget, gpointer data)
{
    ardrone_tool_set_ui_pad_start(1);

    ardrone_at_set_progress_cmd(0,0,0,0,0);

    return C_OK;
}

gint land(GtkWidget *widget, gpointer data)
{
    ardrone_at_set_progress_cmd(0,0,0,0,0);

    ardrone_tool_set_ui_pad_start(0);

    return C_OK;
}

gint emergency(GtkWidget *widget, gpointer data)
{
    int escape_loop=0;

    if (user_navdata.ardrone_state&ARDRONE_EMERGENCY_MASK)
    {
        ardrone_tool_set_ui_pad_select(1);

        while (((user_navdata.ardrone_state)&(ARDRONE_EMERGENCY_MASK))&&(escape_loop<5000))
        {
            usleep(1000);
            escape_loop++;
        }

        ardrone_tool_set_ui_pad_select(0);
    }
    else
    {
        ardrone_tool_set_ui_pad_select(1);

        while ((!((user_navdata.ardrone_state)&(ARDRONE_EMERGENCY_MASK)))&&(escape_loop<5000))
        {
            usleep(1000);
            escape_loop++;
        }

        ardrone_tool_set_ui_pad_select(0);
    }

    if(escape_loop==5000)
        printf("dirty escape\n");

    return C_OK;
}

int animcycle=0;

gint animation(GtkWidget *widget, gpointer data)
{
    ardrone_at_set_anim(7,MAYDAY_TIMEOUT[7]);
    printf("anim %d",animcycle);
    animcycle=(animcycle+1)%10;
    return C_OK;
}

gint delete_event( GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   data )
{
    gtk_main_quit ();
    signal_exit();
    return FALSE;
}

/*visualization window*/

void update_vision_real( void )
{
    char buffer[100];
    vp_os_mutex_lock(&video_update_lock);


    if( pixbuf_data_real != NULL )
    {
        pixbufreal = gdk_pixbuf_new_from_data(pixbuf_data_real,
                                              GDK_COLORSPACE_RGB,
                                              FALSE,
                                              8,
                                              320,
                                              240,
                                              320*3,
                                              NULL,
                                              NULL);

        if( imagereal != NULL )

        {
            gtk_image_set_from_pixbuf(imagereal, pixbufreal);

            sprintf(buffer, "record/real%05d.jpg", debugimagesequence);
            gdk_pixbuf_save (pixbufreal, buffer, "jpeg", NULL, "quality", "100", NULL);

        }

        g_object_unref(pixbufreal);
    }

    vp_os_mutex_unlock(&video_update_lock);

    gtk_widget_show_all( window );
}

void update_vision_robe( void )
{
    vp_os_mutex_lock(&video_update_lock);


    if( pixbuf_data_robe != NULL )
    {
        pixbufrobe = gdk_pixbuf_new_from_data(pixbuf_data_robe,
                                              GDK_COLORSPACE_RGB,
                                              FALSE,
                                              8,
                                              320,
                                              240,
                                              320*3,
                                              NULL,
                                              NULL);

        if( imagerobe != NULL )

        {
            gtk_image_set_from_pixbuf(imagerobe, pixbufrobe);
        }

        g_object_unref(pixbufrobe);
    }

    vp_os_mutex_unlock(&video_update_lock);

    gtk_widget_show_all( window );
}

void update_vision_sword( void )
{
    char buffer[100];
    vp_os_mutex_lock(&video_update_lock);


    if( pixbuf_data_sword != NULL )
    {
        pixbufsword = gdk_pixbuf_new_from_data(pixbuf_data_sword,
                                               GDK_COLORSPACE_RGB,
                                               FALSE,
                                               8,
                                               320,
                                               240,
                                               320*3,
                                               NULL,
                                               NULL);

        if( imagesword != NULL )

        {
            gtk_image_set_from_pixbuf(imagesword, pixbufsword);
            sprintf(buffer, "record/detect%05d.jpg", debugimagesequence);
            gdk_pixbuf_save (pixbufsword, buffer, "jpeg", NULL, "quality", "100", NULL);
        }

        g_object_unref(pixbufsword);
    }

    vp_os_mutex_unlock(&video_update_lock);

    gtk_widget_show_all( window );
}

void update_vision_score(void)
{
    if(infolabel)
    {
        sprintf(strlabel,"height %d\n"
                "distance %d\n"
                "userroll %.05f\n"
                "enable %d\n"
                "battery %d\n"
                "shot frames %d"
                ,user_navdata.navdata_demo.altitude,
                distanceInCmParameter,
                userroll,
                userenable,
                user_navdata.navdata_demo.vbat_flying_percentage,
                shotevaluationrequest);

        gtk_label_set_text(GTK_LABEL(infolabel), strlabel);
    }
    if(scorelabel)
    {
        sprintf(strlabel,"USER SCORE %d\n"
                "DRONE SCORE %d\n",
                user_score,
                drone_score);

        gtk_label_set_text(GTK_LABEL(scorelabel), strlabel);
    }
}

gboolean update_display(gpointer pData)
{
    update_vision_real();
    update_vision_robe();
    update_vision_sword();
    update_vision_score();
    ++debugimagesequence;

    return TRUE;
}




