/*User interface main loop*/

DEFINE_THREAD_ROUTINE(userinterface, data)
{
    GtkWidget *outerbox;
    GtkWidget *frowbox;
    GtkWidget *srowbox;
    GtkWidget *buttonbox;
    GtkWidget *labelbox;
    GtkWidget *takeoffbutton;
    GtkWidget *startchasebutton;
    GtkWidget *startintelbutton;
    GtkWidget *stopintelbutton;
    GtkWidget *stopchasebutton;
    GtkWidget *landbutton;
    GtkWidget *emebutton;
    GtkWidget *anibutton;

    gtk_init (NULL, NULL);

    /* Create our window */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

    /* You should always remember to connect the delete_event signal
     * to the main window. This is very important for proper intuitive
     * behavior */
    g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK (delete_event), NULL);
    gtk_container_set_border_width (GTK_CONTAINER (window), 10);

    outerbox = gtk_vbox_new (FALSE, 0);
    frowbox = gtk_hbox_new (FALSE, 0);
    srowbox = gtk_hbox_new (FALSE, 0);
    buttonbox = gtk_vbox_new (TRUE, 0);
    labelbox = gtk_vbox_new (TRUE, 0);


    gtk_box_pack_start (GTK_BOX (outerbox), frowbox, FALSE, FALSE, 0);

    gtk_box_pack_start (GTK_BOX (outerbox), srowbox, FALSE, FALSE, 0);

    vp_os_mutex_lock(&video_update_lock);

    pixbuf_data_real=vp_os_malloc(320*240*3);

    vp_os_memset(pixbuf_data_real,0,320*240*3);

    pixbufreal = gdk_pixbuf_new_from_data(pixbuf_data_real,
                                      GDK_COLORSPACE_RGB,
                                      FALSE,
                                      8,
                                      320,
                                      240,
                                      320*3,
                                      NULL,
                                      NULL);
    imagereal  = (GtkImage*) gtk_image_new_from_pixbuf( pixbufreal );

    pixbufrobe = gdk_pixbuf_new_from_data(pixbuf_data_robe,
                                      GDK_COLORSPACE_RGB,
                                      FALSE,
                                      8,
                                      320,
                                      240,
                                      320*3,
                                      NULL,
                                      NULL);
    imagerobe  = (GtkImage*) gtk_image_new_from_pixbuf( pixbufrobe );



    pixbufsword = gdk_pixbuf_new_from_data(pixbuf_data_sword,
                                      GDK_COLORSPACE_RGB,
                                      FALSE,
                                      8,
                                      320,
                                      240,
                                      320*3,
                                      NULL,
                                      NULL);
    imagesword  = (GtkImage*) gtk_image_new_from_pixbuf( pixbufsword );

    gtk_box_pack_start (GTK_BOX (frowbox), GTK_WIDGET(imagerobe), FALSE, FALSE, 0);

    gtk_box_pack_start (GTK_BOX (frowbox), GTK_WIDGET(imagereal), FALSE, FALSE, 0);

    gtk_box_pack_start (GTK_BOX (frowbox), GTK_WIDGET(imagesword), FALSE, FALSE, 0);

    g_object_unref(pixbufreal);
    g_object_unref(pixbufrobe);
    g_object_unref(pixbufsword);

    vp_os_free(pixbuf_data_real);

    vp_os_mutex_unlock(&video_update_lock);

    gtk_box_pack_start (GTK_BOX (frowbox), buttonbox, FALSE, FALSE, 0);

    takeoffbutton = gtk_button_new_with_label ("take off");
    gtk_box_pack_start (GTK_BOX (buttonbox), takeoffbutton, FALSE, FALSE, 0);
    g_signal_connect (G_OBJECT (takeoffbutton), "clicked", G_CALLBACK (takeoff), NULL);
    gtk_widget_show (takeoffbutton);

    startchasebutton = gtk_button_new_with_label ("start chase");
    gtk_box_pack_start (GTK_BOX (buttonbox), startchasebutton, FALSE, FALSE, 0);
    g_signal_connect (G_OBJECT (startchasebutton), "clicked", G_CALLBACK (startchase), NULL);
    gtk_widget_show (startchasebutton);

    startintelbutton = gtk_button_new_with_label ("start intel");
    gtk_box_pack_start (GTK_BOX (buttonbox), startintelbutton, FALSE, FALSE, 0);
    g_signal_connect (G_OBJECT (startintelbutton), "clicked", G_CALLBACK (startintel), NULL);
    gtk_widget_show (startintelbutton);

    stopintelbutton = gtk_button_new_with_label ("stop intel");
    gtk_box_pack_start (GTK_BOX (buttonbox), stopintelbutton, FALSE, FALSE, 0);
    g_signal_connect (G_OBJECT (stopintelbutton), "clicked", G_CALLBACK (stoptintel), NULL);
    gtk_widget_show (stopintelbutton);

    stopchasebutton = gtk_button_new_with_label ("stop chase");
    gtk_box_pack_start (GTK_BOX (buttonbox), stopchasebutton, FALSE, FALSE, 0);
    g_signal_connect (G_OBJECT (stopchasebutton), "clicked", G_CALLBACK (stopchase), NULL);
    gtk_widget_show (stopchasebutton);

    landbutton = gtk_button_new_with_label ("land");
    gtk_box_pack_start (GTK_BOX (buttonbox), landbutton, FALSE, FALSE, 0);
    g_signal_connect (G_OBJECT (landbutton), "clicked", G_CALLBACK (land), NULL);
    gtk_widget_show (landbutton);

    emebutton = gtk_button_new_with_label ("eme");
    gtk_box_pack_start (GTK_BOX (buttonbox), emebutton, FALSE, FALSE, 0);
    g_signal_connect (G_OBJECT (emebutton), "clicked", G_CALLBACK (emergency), NULL);
    gtk_widget_show (emebutton);

    anibutton = gtk_button_new_with_label ("animation");
    gtk_box_pack_start (GTK_BOX (buttonbox), anibutton, FALSE, FALSE, 0);
    g_signal_connect (G_OBJECT (anibutton), "clicked", G_CALLBACK (animation), NULL);
    gtk_widget_show (anibutton);

    gtk_box_pack_start (GTK_BOX (frowbox), labelbox, FALSE, FALSE, 0);

    scorelabel=gtk_label_new( NULL );
    gtk_box_pack_start (GTK_BOX (labelbox) ,scorelabel, FALSE, FALSE, 0);
    gtk_widget_modify_font (scorelabel,pango_font_description_from_string ("25"));

    infolabel=gtk_label_new( NULL );
    gtk_box_pack_start (GTK_BOX (labelbox) ,infolabel, FALSE, FALSE, 0);

    gtk_container_add (GTK_CONTAINER (window), outerbox);

    gtk_window_set_title(window,"JediTraining_v3.0");

    gtk_widget_show_all (window);

    g_timeout_add(50, (GtkFunction)update_display, NULL );

    gtk_main();
    return C_OK;
}
